package com.izouma.nineth.web;

import com.izouma.nineth.domain.AirDrop;
import com.izouma.nineth.dto.PageQuery;
import com.izouma.nineth.exception.BusinessException;
import com.izouma.nineth.repo.AirDropRepo;
import com.izouma.nineth.service.AirDropService;
import com.izouma.nineth.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/airDrop")
@AllArgsConstructor
public class AirDropController extends BaseController {
    private AirDropService airDropService;
    private AirDropRepo airDropRepo;

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public AirDrop save(@RequestBody AirDrop record) {
        return airDropService.create(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<AirDrop> all(@RequestBody PageQuery pageQuery) {
        return airDropService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public AirDrop get(@PathVariable Long id) {
        return airDropRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        airDropRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<AirDrop> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

